"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SourceTreeParser = void 0;
const Path = __importStar(require("path"));
const web_tree_sitter_1 = __importDefault(require("web-tree-sitter"));
const mockElmWorkspace_1 = require("./mockElmWorkspace");
class SourceTreeParser {
    init() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.parser) {
                return;
            }
            yield web_tree_sitter_1.default.init();
            const absolute = Path.join(__dirname, "../../../tree-sitter-elm.wasm");
            const pathToWasm = Path.relative(process.cwd(), absolute);
            const language = yield web_tree_sitter_1.default.Language.load(pathToWasm);
            this.parser = new web_tree_sitter_1.default();
            this.parser.setLanguage(language);
        });
    }
    getWorkspace(source) {
        return new mockElmWorkspace_1.MockElmWorkspace(source.join("\n"), this.parser);
    }
}
exports.SourceTreeParser = SourceTreeParser;
//# sourceMappingURL=sourceTreeParser.js.map